
my (%aliasmapping);

sub map_alias {
    use SNMP_MIB;
    use SNMP_Simple;

    my ($target) = @_;
    my $host = expandString($target->{'snmp-host'}, $target);
    my $community = expandString($target->{'snmp-community'}, $target);
    my $oids = $target->{'oids'};
    return 0 unless defined($target->{'if-alias'}, 2);
    my ($port, $junk) = split(' ', $target->{'if-alias'}, 2);
    my $mapping = $aliasmapping{$host};

    if (!defined($mapping)) {
        $mapping = {};
        &SNMP_MIB::loadoids($oids, 'IF');
        my $session = SNMP_Simple->open($host, $community);
        my %ifAlias = $session->snmpgettablean('ifAlias');

        my $interface;
        foreach $interface (sort { $a <=> $b } keys %ifAlias) {
            my ($alias, $rest) = split(' ', $ifAlias{$interface}, 2);
            next if (!defined($alias) || $alias eq "");
            my ($base, $unique) = split(/;/, $alias, 2);
            $unique = 1 if (!defined($unique) || $unique eq "");
            while (defined($mapping->{"$base;$unique"})) {
                $unique++;
            }
            $mapping->{"$base;$unique"} = $interface;
        }
        $aliasmapping{$host} = $mapping;

        #For some reason, this closes more than I expect.  So don't do it. :-(
        #$session->close();
    } 
    
    return $mapping->{$port} if (defined($mapping->{$port}));
    return 0;
}

