
my (%portmapping);

sub map_port {
    use SNMP_MIB;
    use SNMP_Simple;
    
    my($target) = @_;
    my $host = expandString($target->{'snmp-host'}, $target);
    my $community = expandString($target->{'snmp-community'}, $target);
    my $oids = $target->{'oids'};
    my $port = $target->{'port-name'};
    my $mapping = $portmapping{$host};

    if (!defined($mapping)) {
	$mapping = {};
	&SNMP_MIB::loadoids($oids, 'CISCO-STACK');
	my $session = SNMP_Simple->open($host, $community);
	my %portEntries = $session->snmpgettableka(2, 'portName',
						   'portIfIndex');
	my $portkey;
	foreach $portkey (keys %portEntries) {
	    next if ($portEntries{$portkey}->{'portName'} eq "");
	    $mapping->{$portEntries{$portkey}->{'portName'}} =
		$portEntries{$portkey}->{'portIfIndex'};
	}
	$portmapping{$host} = $mapping;

	#For some reason, this closes more than I expect.  So don't do it. :-(
        #$session->close();
    } 
    
    return $mapping->{$port} if (defined($mapping->{$port}));
    return 0;
}

